/*
 *      __ ________               _____                               ______          __    
 *     / //_/_  __/___ _____ _   / ___/____  __  _______________     / ____/___  ____/ /__  
 *    / ,<   / / / __ `/ __ `/   \__ \/ __ \/ / / / ___/ ___/ _ \   / /   / __ \/ __  / _ \ 
 *   / /| | / / / /_/ / /_/ /   ___/ / /_/ / /_/ / /  / /__/  __/  / /___/ /_/ / /_/ /  __/ 
 *  /_/ |_|/_/  \__,_/\__, /   /____/\____/\__,_/_/   \___/\___/   \____/\____/\__,_/\___/  
 *                   /____/                                                                 
 *
 *  🃞 THIS FILE IS PART OF THE KTAG SOURCE CODE.  Visit https://ktag.clubk.club/ for more. 🃞
 *
 */

/** \file
 *  \brief [Autogenerated] This file defines the OnChip EEPROM entries.
 *
 *  \note AUTOGENERATED: This file was generated automatically on Friday, April 28, 2023 at 11:31:31 AM.
 *                       DO NOT MODIFY THIS FILE MANUALLY!
 */

/* Include Files */
#include "KTag.h"

/* EEPROM Entries */

/** \defgroup NVM_ONCHIP_EEPROM NVM OnChip EEPROM
 *
 * The OnChip EEPROM is divided into logical "entries", represented by instances of the #NVM_EEPROMEntry_T type.
 * At startup, these entries are loaded into their respective RAM copies by NVM_InitOnChipEEPROM().  The application
 * then updates the RAM copies directly, and requests that the NVM_OnChipEEPROMTask() save these back to the EEPROM
 * when necessary.
 * @{ */

static NVM_OnChip_Test_T RAM_OnChip_Test;

static const NVM_OnChip_Test_T DEFAULT_OnChip_Test = 
{
    //! Test Code 1
    .OnChip_Test_1 = UINT16_MAX,
    //! Test Code 2
    .OnChip_Test_2 = UINT32_MAX,
};

NVM_EEPROMEntry_T NVM_OnChip_Test = 
{
    //! Size == sizeof(NVM_OnChip_Test_T)
    .Size = 6,
    .EE_Address = 0,
    .EE_CRC_Address = 6,
    .Value = (uint8_t *)&RAM_OnChip_Test,
    .Default = (uint8_t *)&DEFAULT_OnChip_Test,
    .State = NVM_STATE_UNINITIALIZED
};

/** @} */

NVM_EEPROMEntry_T * const NVM_OnChipEEPROMEntries[] =
{
    &NVM_OnChip_Test,
};

//! Size of the #NVM_OnChipEEPROMEntries array (i.e. the number of OnChip EEPROM entries).
const uint8_t NVM_N_ONCHIP_EEPROM_ENTRIES = (uint8_t) (sizeof(NVM_OnChipEEPROMEntries) / sizeof(NVM_EEPROMEntry_T *));

